<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusTaxonTypePlugin\Application\src\Factory;

use Dedi\SyliusTaxonTypePlugin\Model\TypedTaxonInterface;
use Sylius\Component\Taxonomy\Factory\TaxonFactoryInterface as BaseTaxonFactoryInterface;
use Tests\Dedi\SyliusTaxonTypePlugin\Application\src\Entity\TaxonInterface;

class TaxonFactory implements TaxonFactoryInterface
{
    private BaseTaxonFactoryInterface $decoratedFactory;

    public function __construct(BaseTaxonFactoryInterface $decoratedFactory)
    {
        $this->decoratedFactory = $decoratedFactory;
    }

    public function createNew(): TaxonInterface
    {
        /** @var TaxonInterface $taxon */
        $taxon = $this->decoratedFactory->createNew();
        $taxon->setType(TypedTaxonInterface::DEFAULT_TYPE);

        return $taxon;
    }

    public function createBrand(): TaxonInterface
    {
        /** @var TaxonInterface $taxon */
        $taxon = $this->decoratedFactory->createNew();
        $taxon->setType(TypedTaxonInterface::BRAND_TYPE);

        return $taxon;
    }
}